#!/usr/bin/perl

use strict;
use CGI;
use CGI::Carp qw(fatalsToBrowser);
use CGI::Session;

# Check for Cookie or err
my $cgi = new CGI;
my $sid = $cgi->cookie("VIPAR_CGISESSID") || &err_login();

my $session = CGI::Session->load($sid);
&err_login() if $session->is_expired();
$session->expire('+1h');
my $uid = $session->param("userid");

my $form = new CGI;

my $p = $form->param('p');
my $d = $form->param('d');
my $t = $form->param('t');
my $f = $form->param('f');
my $l = $form->param('l');
my $filelocation = $ENV{'VIPAR_ROOT'}."/projects";
my $filepath = "$filelocation\/project_$p\/$d\/$t\/$f";
$filepath = "$filelocation\/project_$p\/codelibs/$l"."libs\/$f" if $l;
my $ext = "txt";
if ($f =~ /\w+\.(\w+)$/){
        $ext = $1;
        }
my $content = &content_type(lc($ext));

open(DLFILE, "<$filepath");
my @fileholder = <DLFILE>;
close (DLFILE);

        print "Content-Type:$content\n";
        print "Content-Disposition:attachment;filename=\"$f\"\n\n";
        print @fileholder;

sub content_type {
my $ext = shift;
my $type = "";
my %mime_hash = ();
$mime_hash{'323'} = "text/h323";
$mime_hash{'acx'} = "application/internet-property-stream";
$mime_hash{'ai'} = "application/postscript";
$mime_hash{'aif'} = "audio/x-aiff";
$mime_hash{'aifc'} = "audio/x-aiff";
$mime_hash{'aiff'} = "audio/x-aiff";
$mime_hash{'asf'} = "video/x-ms-asf";
$mime_hash{'asr'} = "video/x-ms-asf";
$mime_hash{'asx'} = "video/x-ms-asf";
$mime_hash{'au'} = "audio/basic";
$mime_hash{'avi'} = "video/x-msvideo";
$mime_hash{'axs'} = "application/olescript";
$mime_hash{'bas'} = "text/plain";
$mime_hash{'bcpio'} = "application/x-bcpio";
$mime_hash{'bin'} = "application/octet-stream";
$mime_hash{'bmp'} = "image/bmp";
$mime_hash{'c'} = "text/plain";
$mime_hash{'cat'} = "application/vnd.ms-pkiseccat";
$mime_hash{'cdf'} = "application/x-cdf";
$mime_hash{'cer'} = "application/x-x509-ca-cert";
$mime_hash{'class'} = "application/octet-stream";
$mime_hash{'clp'} = "application/x-msclip";
$mime_hash{'cmx'} = "image/x-cmx";
$mime_hash{'cod'} = "image/cis-cod";
$mime_hash{'cpio'} = "application/x-cpio";
$mime_hash{'crd'} = "application/x-mscardfile";
$mime_hash{'crl'} = "application/pkix-crl";
$mime_hash{'crt'} = "application/x-x509-ca-cert";
$mime_hash{'csh'} = "application/x-csh";
$mime_hash{'css'} = "text/css";
$mime_hash{'dcr'} = "application/x-director";
$mime_hash{'der'} = "application/x-x509-ca-cert";
$mime_hash{'dir'} = "application/x-director";
$mime_hash{'dll'} = "application/x-msdownload";
$mime_hash{'dms'} = "application/octet-stream";
$mime_hash{'do'} = "text/plain";
$mime_hash{'doc'} = "application/msword";
$mime_hash{'dot'} = "application/msword";
$mime_hash{'dvi'} = "application/x-dvi";
$mime_hash{'dxr'} = "application/x-director";
$mime_hash{'eps'} = "application/postscript";
$mime_hash{'etx'} = "text/x-setext";
$mime_hash{'evy'} = "application/envoy";
$mime_hash{'exe'} = "application/octet-stream";
$mime_hash{'fif'} = "application/fractals";
$mime_hash{'flr'} = "x-world/x-vrml";
$mime_hash{'gif'} = "image/gif";
$mime_hash{'gtar'} = "application/x-gtar";
$mime_hash{'gz'} = "application/x-gzip";
$mime_hash{'h'} = "text/plain";
$mime_hash{'hdf'} = "application/x-hdf";
$mime_hash{'hlp'} = "application/winhlp";
$mime_hash{'hqx'} = "application/mac-binhex40";
$mime_hash{'hta'} = "application/hta";
$mime_hash{'htc'} = "text/x-component";
$mime_hash{'htm'} = "text/html";
$mime_hash{'html'} = "text/html";
$mime_hash{'htt'} = "text/webviewhtml";
$mime_hash{'ico'} = "image/x-icon";
$mime_hash{'ief'} = "image/ief";
$mime_hash{'iii'} = "application/x-iphone";
$mime_hash{'ins'} = "application/x-internet-signup";
$mime_hash{'isp'} = "application/x-internet-signup";
$mime_hash{'jfif'} = "image/pipeg";
$mime_hash{'jpe'} = "image/jpeg";
$mime_hash{'jpeg'} = "image/jpeg";
$mime_hash{'jpg'} = "image/jpeg";
$mime_hash{'js'} = "application/x-javascript";
$mime_hash{'latex'} = "application/x-latex";
$mime_hash{'lha'} = "application/octet-stream";
$mime_hash{'lsf'} = "video/x-la-asf";
$mime_hash{'lsx'} = "video/x-la-asf";
$mime_hash{'lzh'} = "application/octet-stream";
$mime_hash{'m13'} = "application/x-msmediaview";
$mime_hash{'m14'} = "application/x-msmediaview";
$mime_hash{'m3u'} = "audio/x-mpegurl";
$mime_hash{'man'} = "application/x-troff-man";
$mime_hash{'mdb'} = "application/x-msaccess";
$mime_hash{'me'} = "application/x-troff-me";
$mime_hash{'mht'} = "message/rfc822";
$mime_hash{'mhtml'} = "message/rfc822";
$mime_hash{'mid'} = "audio/mid";
$mime_hash{'mny'} = "application/x-msmoney";
$mime_hash{'mov'} = "video/quicktime";
$mime_hash{'movie'} = "video/x-sgi-movie";
$mime_hash{'mp2'} = "video/mpeg";
$mime_hash{'mp3'} = "audio/mpeg";
$mime_hash{'mpa'} = "video/mpeg";
$mime_hash{'mpe'} = "video/mpeg";
$mime_hash{'mpeg'} = "video/mpeg";
$mime_hash{'mpg'} = "video/mpeg";
$mime_hash{'mpp'} = "application/vnd.ms-project";
$mime_hash{'mpv2'} = "video/mpeg";
$mime_hash{'ms'} = "application/x-troff-ms";
$mime_hash{'mvb'} = "application/x-msmediaview";
$mime_hash{'nws'} = "message/rfc822";
$mime_hash{'oda'} = "application/oda";
$mime_hash{'p10'} = "application/pkcs10";
$mime_hash{'p12'} = "application/x-pkcs12";
$mime_hash{'p7b'} = "application/x-pkcs7-certificates";
$mime_hash{'p7c'} = "application/x-pkcs7-mime";
$mime_hash{'p7m'} = "application/x-pkcs7-mime";
$mime_hash{'p7r'} = "application/x-pkcs7-certreqresp";
$mime_hash{'p7s'} = "application/x-pkcs7-signature";
$mime_hash{'pbm'} = "image/x-portable-bitmap";
$mime_hash{'pdf'} = "application/pdf";
$mime_hash{'pfx'} = "application/x-pkcs12";
$mime_hash{'pgm'} = "image/x-portable-graymap";
$mime_hash{'pko'} = "application/ynd.ms-pkipko";
$mime_hash{'pma'} = "application/x-perfmon";
$mime_hash{'pmc'} = "application/x-perfmon";
$mime_hash{'pml'} = "application/x-perfmon";
$mime_hash{'pmr'} = "application/x-perfmon";
$mime_hash{'pmw'} = "application/x-perfmon";
$mime_hash{'png'} = "image/png";
$mime_hash{'pnm'} = "image/x-portable-anymap";
$mime_hash{'pot,'} = "application/vnd.ms-powerpoint";
$mime_hash{'ppm'} = "image/x-portable-pixmap";
$mime_hash{'pps'} = "application/vnd.ms-powerpoint";
$mime_hash{'ppt'} = "application/vnd.ms-powerpoint";
$mime_hash{'prf'} = "application/pics-rules";
$mime_hash{'ps'} = "application/postscript";
$mime_hash{'pub'} = "application/x-mspublisher";
$mime_hash{'qt'} = "video/quicktime";
$mime_hash{'r'} = "text/plain";
$mime_hash{'R'} = "text/plain";
$mime_hash{'ra'} = "audio/x-pn-realaudio";
$mime_hash{'ram'} = "audio/x-pn-realaudio";
$mime_hash{'ras'} = "image/x-cmu-raster";
$mime_hash{'rgb'} = "image/x-rgb";
$mime_hash{'rmi'} = "audio/mid";
$mime_hash{'roff'} = "application/x-troff";
$mime_hash{'rtf'} = "application/rtf";
$mime_hash{'rtx'} = "text/richtext";
$mime_hash{'sas'} = "text/plain";
$mime_hash{'scd'} = "application/x-msschedule";
$mime_hash{'sct'} = "text/scriptlet";
$mime_hash{'setpay'} = "application/set-payment-initiation";
$mime_hash{'setreg'} = "application/set-registration-initiation";
$mime_hash{'sh'} = "application/x-sh";
$mime_hash{'shar'} = "application/x-shar";
$mime_hash{'sit'} = "application/x-stuffit";
$mime_hash{'snd'} = "audio/basic";
$mime_hash{'spc'} = "application/x-pkcs7-certificates";
$mime_hash{'spl'} = "application/futuresplash";
$mime_hash{'src'} = "application/x-wais-source";
$mime_hash{'sst'} = "application/vnd.ms-pkicertstore";
$mime_hash{'stl'} = "application/vnd.ms-pkistl";
$mime_hash{'stm'} = "text/html";
$mime_hash{'svg'} = "image/svg+xml";
$mime_hash{'sv4cpio'} = "application/x-sv4cpio";
$mime_hash{'sv4crc'} = "application/x-sv4crc";
$mime_hash{'swf'} = "application/x-shockwave-flash";
$mime_hash{'t'} = "application/x-troff";
$mime_hash{'tar'} = "application/x-tar";
$mime_hash{'tcl'} = "application/x-tcl";
$mime_hash{'tex'} = "application/x-tex";
$mime_hash{'texi'} = "application/x-texinfo";
$mime_hash{'texinfo'} = "application/x-texinfo";
$mime_hash{'tgz'} = "application/x-compressed";
$mime_hash{'tif'} = "image/tiff";
$mime_hash{'tiff'} = "image/tiff";
$mime_hash{'tr'} = "application/x-troff";
$mime_hash{'trm'} = "application/x-msterminal";
$mime_hash{'tsv'} = "text/tab-separated-values";
$mime_hash{'txt'} = "text/plain";
$mime_hash{'uls'} = "text/iuls";
$mime_hash{'ustar'} = "application/x-ustar";
$mime_hash{'vcf'} = "text/x-vcard";
$mime_hash{'vrml'} = "x-world/x-vrml";
$mime_hash{'wav'} = "audio/x-wav";
$mime_hash{'wcm'} = "application/vnd.ms-works";
$mime_hash{'wdb'} = "application/vnd.ms-works";
$mime_hash{'wks'} = "application/vnd.ms-works";
$mime_hash{'wmf'} = "application/x-msmetafile";
$mime_hash{'wps'} = "application/vnd.ms-works";
$mime_hash{'wri'} = "application/x-mswrite";
$mime_hash{'wrl'} = "x-world/x-vrml";
$mime_hash{'wrz'} = "x-world/x-vrml";
$mime_hash{'xaf'} = "x-world/x-vrml";
$mime_hash{'xbm'} = "image/x-xbitmap";
$mime_hash{'xla'} = "application/vnd.ms-excel";
$mime_hash{'xlc'} = "application/vnd.ms-excel";
$mime_hash{'xlm'} = "application/vnd.ms-excel";
$mime_hash{'xls'} = "application/vnd.ms-excel";
$mime_hash{'xlt'} = "application/vnd.ms-excel";
$mime_hash{'xlw'} = "application/vnd.ms-excel";
$mime_hash{'xof'} = "x-world/x-vrml";
$mime_hash{'xpm'} = "image/x-xpixmap";
$mime_hash{'xwd'} = "image/x-xwindowdump";
$mime_hash{'z'} = "application/x-compress";
$mime_hash{'zip'} = "application/zip";

$type = $mime_hash{$ext};
return($type);
}

sub err_login {
print $cgi->header();
print $cgi->start_html(
	-title=>'Virtual Pooling and Analysis of Research - ViPAR',
	-style=>{'src'=>"/viparstyle/vipar.css"}
);
my $url = '/vipar';
print "<script>alert(\"Your login to ViPAR has timed out (or you have not logged in yet). You will be returned to the login page. If you have any further problems, please contact the site administrators.\");</script>";
print $cgi->end_html();

print "<meta http-equiv=\"refresh\" content=\"0;URL=$url\">\n";

exit(1);
}
